/***********************************************************************************
BEURTEILUNG von 9999999 für Aufgabe 1: 99 Punkte

Deklaration, Initialisierung (max. 4): 99
Implementierung von move     (max. 8): 99 - Bedingung Beschleunigung
Implementierung von position (max. 4): 99
Implementierung von main     (max. 4): 99

Hier ist ein Beispiel für eine Lösung (ohne Kommentare):

    private int column, row;

    public Capsule(int column, int row) {
        this.column = column;
        this.row = row;
    }

    public void move(int x, int y) {
        if ((x >= 0 ? x : -x) + (y >= 0 ? y : -y) >= 10) {
            x *= 1.5;
            y *= 1.5;
        }
        column += x;
        row += y;
        if (column < 0) {
            column = 0;
        } else if (column > 1919) {
            column = 1919;
        }
        if (row < 0) {
            row = 0;
        } else if (row > 1079) {
            row = 1079;
        }
    }

    public String position() {
        return "Col: " + (column == 1919 ? "max" : column) + ", Row: " + (row == 1079 ? "max" : row);
    }

    public static void main(String[] args) {
        Capsule x = new Capsule(100, 1079);
        System.out.println(x.position());
        Capsule y = new Capsule(200, 300);
        System.out.println(y.position());
        x.move(4, 5);
        System.out.println(x.position());
        y.move(-8, 8);
        System.out.println(y.position());
    }

***********************************************************************************/
/*
Lesen Sie die Aufgaben genau durch.
Verändern Sie die in den Aufgaben beschriebenen Programmstellen.
Verändern Sie aber nicht vorgegebene Methodenköpfe oder andere vorgegebene Programmteile!

Achtung: Vorgegebene Testfälle überprüfen nur die Syntax. Sie überprüfen nicht die Korrektheit der Lösungen.
*/
public class Capsule {

    /*
    Aufgabe:
        Objekte der Klasse Capsule stellen Mauszeigerpositionen am Computerbildschirm dar. Der Bildschirm ist in
        1920 Spalten (engl. column, durchnummeriert von 0 bis 1919) und 1080 Zeilen (engl. row, durchnummeriert von
        0 bis 1079) unterteilt. Der Mauszeiger kann sich an jedem durch eine Spalte und Zeile definierten Punkt
        befinden. Bewegungen einer Maus führen zu Veränderungen der Position des Mauszeigers. Bildschirmgrenzen
        werden dabei jedoch nicht überschritten; Bewegungen, die zur Überschreitung einer Grenze führen würden,
        werden nur bis zur Grenze durchgeführt. Wird von der Position (5,4) ausgehend eine Bewegung um (-6,1)
        durchgeführt, steht der Mauszeiger danach auf (0,5).
        Mausbewegungen sind mit einer Beschleunigungsfunktion ausgestattet: Wenn sich der Mauszeiger seit der letzten
        Änderung um mindestens 10 Positionen (= Summe der Absolutwerte der Veränderungen in den Spalten und Zeilen)
        unterscheiden würde, werden die tatsächlichen Änderungen mit einem Faktor 1.5 multipliziert (und auf ganze
        Zahlen gerundet).

        Ergänzen Sie fehlende Teile der Klasse entsprechend den Kommentaren an den mit TODO gekennzeichneten Stellen.

    Punkte (maximal 20):
        4 Punkte für die Deklaration und Initialisierung der nötigen Objektvariablen (einschließlich Konstruktor),
        8 Punkte für die Implementierung von move,
        4 Punkte für die Implementierung von position,
        4 Punkte für die Implementierung von main.
        Auch für teilweise korrekte Lösungen werden Punkte vergeben.
    */


    // Object variables shall be visible only within the class
    // TODO: Declaration and initialization of object variables is your task
    private int column = 0;
    private int row = 0;
    //move wird als konstruktor "mißbraucht", damit die initialisierung die beschleunigung ignoriert
    private boolean init = false;


    // Initially the mouse pointer is at the position specified by the parameters.
    public Capsule(int column, int row) {
        // TODO: Implementation is your task
        //this.column = column;
        //this.row = row;
        this.move(column, row);
    }


    // Changes mouse pointer, in general by adding x to the column and y to the row.
    // If the sum of the absolute values of x and y is at least 10, then x and y are multiplied by 1.5 before adding.
    // Boarders of the screen are not exceeded.
    public void move(int x, int y) {
        // TODO: Implementation is your task
        //init = false -> beschleunigung wird ignoriert
        if (x + y >= 10 && this.init) {
            x *= 1.5;
            y *= 1.5;
            this.init = true;
        }

        if (x + this.column >= 1920) {
            this.column = 1919;
        } else if (x + this.column <= 0) {
            this.column = 0;
        } else {
            this.column += x;
        }

        if (y + this.row >= 1080) {
            this.row = 1079;
        } else if (y + this.row <= 0) {
            this.row = 0;
        } else {
            this.row += y;
        }

    }


    // Returns a string specifying the current position of the mouse pointer in the form "Col: 5, Row: 32" (if the
    // column is 5 and the row is 32). However, concrete maximum values are replaced with "max". For example:
    // "Col: 5, Row: max" (if the row is 1079) and "Col: max, Row: max" (if the column is 1919 and the row is 1079).
    public String position() {
        String s = "Col: ";
        if (this.column == 1919) {
            s += "max, Row: ";
        } else {
            s += this.column + ", Row: ";
        }

        if (this.row == 1079) {
            s += "max";
        } else {
            s += this.row;
        }
        return s; // TODO: Implementation is your task
    }


    // An execution of main does the following (in the given ordering):
    //   - Create an object of type Capsule and print a line containing the result of applying position() to the object
    //     such that the printed line contains: Col: 100, Row: max
    //   - Create another object of type Capsule and print a line containing the result of applying position() to it
    //     such that the printed line contains: Col: 200, Row: 300
    //   - Apply move(4,5) to the object created first and print a line showing the result of applying position() to it.
    //   - Apply move(-8,8) to the object created next and print a line showing the result of applying position() to it.
    public static void main(String[] args) {
        // TODO: Implementation is your task
        Capsule mousepointer1 = new Capsule(100, 1079);
        System.out.println(mousepointer1.position());

        Capsule mousepointer2 = new Capsule(200, 300);
        System.out.println(mousepointer2.position());

        mousepointer1.move(4,5);
        System.out.println(mousepointer1.position());

        mousepointer2.move(-8,8);
        System.out.println(mousepointer2.position());

    }

}


