/***********************************************************************************
BEURTEILUNG von 9999999 für Aufgabe 2: 99 Punkte - 15

Initialisierung,Konstruktor  (max. 8): 99 - city vom Typ TreeMap
addFromArrays                (max. 8): 9
getFromArray                 (max. 4): 9
main                         (max. 5): 9 - unvollständig

Hier ist ein Beispiel für eine Lösung (ohne Kommentare):

    private Map<String, String> city = new TreeMap<String, String>();

    public Mapping(Queue<String> addresses) {
        if (addresses != null) {
            String address;
            while ((address = addresses.poll()) != null) {
                if (city.put(address, "Building at " + address) != null) {
                    city.put(address, "More than one building at " + address);
                }
            }
        }
    }

    public int addFromArrays(String[] addresses, String[] descriptions, boolean[] changes) {
        if (addresses == null || descriptions == null || changes == null ||
                addresses.length != descriptions.length || addresses.length != changes.length) {
            return -1;
        }
        int count = 0;
        for (int i = 0; i < addresses.length; i++) {
            if (changes[i] || ! city.containsKey(addresses[i])) {
                city.put(addresses[i], descriptions[i]);
                changes[i] = true;
                count++;
            }
        }
        return count;
    }

    public String[] getFromArray(String[] addresses) {
        String[] result = null;
        if (addresses != null) {
            result = new String[addresses.length];
            for (int i = 0; i < addresses.length; i++) {
                result[i] = city.get(addresses[i]);
            }
        }
        return result;
    }

    public static void main(String[] args) {
        Queue<String> addrQ = new LinkedList<String>();
        for (int i = 1; i <= 100; i++) {
            addrQ.offer("Main Street " + i);
        }
        addrQ.offer("Main Street 1");
        Mapping map = new Mapping(addrQ);
        String[] addr = { "Main Street 1", "Main Street 2", "Main Square 1" };
        String[] read = map.getFromArray(addr);
        for (String s : read) {
            System.out.println(s);
        }
        String[] descr = { "New building 1", "New building 2", "New building 3" };
        boolean[] change = { false, true, false };
        System.out.println(map.addFromArrays(addr, descr, change));
        for (boolean b : change) {
            System.out.println(b);
        }
        read = map.getFromArray(addr);
        for (String s : read) {
            System.out.println(s);
        }
    }

***********************************************************************************/
import java.util.LinkedList;
import java.util.Map;
import java.util.Queue;
import java.util.TreeMap;

public class Mapping {

    /*
    Aufgabe:
        Objekte der Klasse Mapping simulieren ein Verzeichnis der Gebäude einer Stadt. Zu einer gegebenen Adresse
        (ein String bestehend aus dem Straßennamen und der Hausnummer) findet man eine Beschreibung des Gebäudes.

        Ergänzen Sie fehlende Teile der Klasse entsprechend den Kommentaren an den mit TODO gekennzeichneten Stellen.

    Punkte (maximal 25):
        8 Punkte für die Deklaration und Initialisierung der nötigen Objektvariable und den Konstruktor,
        8 Punkte für addFromArrays,
        4 Punkte für getFromArray,
        5 Punkte für main.
        Auch für teilweise korrekte Lösungen werden Punkte vergeben.
    */

    // The object variable 'city' of type Map<String, String> associates addresses with descriptions of buildings.
    // 'city' is visible only within the class.
    // TODO: Declaration and initialization of 'city' is your task
    private TreeMap<String, String> city = new TreeMap<String, String>();
    // Note: TreeMap<String, String> may be useful for object initialization.


    // On object construction, each address in 'addresses'  is associated with a simple building description of the
    // form "Building at ..." where ... is replaced with the address. However, if an address occurs several times
    // in 'addresses', the building description for this address is of the form "More than one building at ...".
    // If 'addresses' is null, no addresses are added to the data structure.
    public Mapping(Queue<String> addresses) {
        // TODO: Implementation is your task
        String temp = "";
        if (addresses != null) {
            while  (addresses.peek() != null) {
                temp = addresses.poll();
                if (this.city.containsKey(temp)) {
                    this.city.put(temp, "More than one building at " + temp);
                } else {
                    this.city.put(temp, "Building at " + temp);
                }
            }
        }
    }


    // addFromArrays adds and changes building descriptions. For an index i, addresses[i] specifies the address of a
    // building and descriptions[i] the corresponding description. The description for this address is added if there
    // did not already exist a description for the same address before. If a description already existed, the old
    // description is replaced with the new one only if changes[i] is true; otherwise the description is not changed.
    // addFromArrays updates 'changes': On return changes[i] is true if the description of address[i] was added or
    // changed, and changes[i] is false if the description was not changed.
    // If any of the parameters is null or these arrays are of different sizes, then nothing is added or changed and
    // -1 is returned as result; otherwise the number of added or changed building descriptions is returned.
    public int addFromArrays(String[] addresses, String[] descriptions, boolean[] changes) {

        return 0; // TODO: Implementation is your task
    }


    // The array returned by getFromArray is of the same size as 'addresses' and contains at index i the
    // description of the building at addresses[i] (or null if there is no description for the address).
    // If 'addresses' is null, then null is returned.
    public String[] getFromArray(String[] addresses) {
        if (addresses == null) {
            return null;
        }

        String[] result = new String[addresses.length];

        for (int i = 0; i < result.length; i++) {
            if (this.city.containsKey(addresses[i])) {
                result[i] = this.city.get(addresses[i]);
            } else {
                result[i] = null;
            }
        }
        return result; // TODO: Implementation is your task
    }


    // An execution of main does the following (in the given ordering):
    //   - A variable of type Queue<String> is initialized with a new object of type LinkedList<String>, and the
    //     strings "Main Street 1", ..., "Main Street 100" are added to the queue; "Main Street 1" is added twice.

    //   - A new object of type Mapping is created (using the queue as argument of the constructor).

    //   - The building descriptions at the addresses "Main Street 1", "Main Street 2" and "Main Square 1" are
    //     computed (by a single invocation of getFromArray) and printed - each description on a separate line.

    //   - addFromArrays is invoked with the addresses "Main Street 1", "Main Street 2" and "Main Square 1", the
    //     descriptions "New building 1", "New building 2" and "New building 3", and a boolean array containing
    //     false, true and false. The result is printed, and then the (new) values in the boolean array are printed
    //     (each value on a separate line).

    //   - The building descriptions at the addresses "Main Street 1", "Main Street 2" and "Main Square 1" are
    //     computed and printed again - each description on a separate line.
    public static void main(String[] args) {
        // TODO: Implementation is your task
        Queue<String> xxx = new LinkedList<String>();
        xxx.add("Main Street 1");
        for (int i = 1; i <= 100; i++) {
            xxx.add("Main Street " + i);
        }

        Mapping map = new Mapping(xxx);

        String[] description = {"Main Street 1", "Main Street 2", "Main Street 1"};
        String [] desc1 = map.getFromArray(description);
        for (int i = 0; i < desc1.length; i++) {
            System.out.println(desc1[i]);
        }



    }

}


